import pygame, sys, random, time
from pygame.locals import *
import cPickle as P

blank='''

>>>
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
>>>
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00 00 00
>>>

'''



#get info
world=raw_input('world name?')
mapnumber=raw_input('room number?')

filename='mappieces/'+world+'/'+mapnumber+'.txt'

pygame.init()

#set up settings
settings={'screenresolution': (896,672)}

#set up window
window=pygame.display.set_mode(settings['screenresolution'])
pygame.display.set_caption('Backyard labyrinth map editor')

def quit():
	pygame.quit
	sys.exit()

def save():
	f=open(filename, 'w')
	f.write('>>>\n')
	for y in range(len(editroom.tiles)-1):
		for x in range(len(editroom.tiles[y])):
			f.write(editroom.tiles[y][x])
			if x!=9:
				f.write(' ')
		f.write('\n')
	f.write('>>>\n')
	for y in range(len(editroom.objects)-1):
		for x in range(len(editroom.objects[y])):
			f.write(editroom.objects[y][x])
			if x!=9:
				f.write(' ')
		f.write('\n')
	f.write('>>>\n')
	f.close()

def change_tilemenu():
	buttons2=[]	
	a=0
	while True:
		try:
			if a < 10:
				b=tileset+'0'+str(a)
			else:
				b=tileset+str(a)
			if tileset!='':
				x=int(b[1])*64+640
				y=int(b[2])*64+64
			else:
				x=int(b[0])*64+640
				y=int(b[1])*64+64
			image=pygame.image.load('images/tiles/'+world+'/'+b+'.png')
			buttons2.append(button2(image,pygame.Rect(x,y,32,32),b))
			a+=1
		except:
			break
	
	return buttons2
		
class room():
	def __init__(self, lines, world):
		self.world=world
		
		self.tiles=[]
		sublines=lines.split('>>>\n')
		y=sublines[1].split('\n')
		for i in y:
			self.tiles.append(i.split(' '))
				
		
		self.objects=[]
		y=sublines[2].split('\n')
		for i in y:
			self.objects.append(i.split(' '))
		pygame.display.update()
		

	def draw(self):
	
		self.image=pygame.Surface((640,640))

		for y in range(len(self.tiles)-1):
			for x in range(len(self.tiles[y])):
				image=pygame.image.load('images/tiles/'+self.world+'/'+self.tiles[y][x]+'.png')
				image.set_colorkey((255,255,255))
				imageb = pygame.transform.scale(image, (64, 64))
				self.image.blit(imageb, (x*64, y*64, 64, 64)) 
		window.blit(self.image, (0,0,640,640))
	
		for y in range(len(self.objects)-1):
			for x in range(len(self.objects[y])):
				
				pic=pygame.image.load('images/tiles/'+self.world+'/'+self.objects[y][x]+'.png')
				pic.set_colorkey((255,255,255))
				imageb = pygame.transform.scale(pic, (64, 64))
				window.blit(imageb, (x*64, y*64, 64, 64)) 	
		pygame.display.update()
		

class tile():
	def __init__(self, x, y):
		self.x=x
		self.y=y
		self.pos=pygame.Rect(x*64,y*64,64,64)
		
class button():
	def __init__(self,image,pos,set):
		self.image=image
		self.pos=pos
		self.set=set	
		
class button2():
	def __init__(self,image,pos,number):
		self.image=image
		self.pos=pos
		self.number=number		
		
#open file

try:
	f=open(filename, 'r')
	lines=f.read()
	editroom=room(lines, world)
	f.close()
	
except:
	f=open(filename, 'w')
	f.write(blank)
	f.close()
	
	f=open(filename, 'r')
	lines=f.read()
	editroom=room(lines, world)
	f.close()

#set up tiles
tiles=[]
for y in range(10):
	for x in range(10):
		tiles.append(tile(x,y))	
		
tileset='f'

currenttile='f00'

buttons=[]
but1=pygame.image.load('images/other/button1.png')
but1.set_colorkey((255,255,255))
but2=pygame.image.load('images/other/button2.png')
but2.set_colorkey((255,255,255))
but3=pygame.image.load('images/other/button3.png')
but3.set_colorkey((255,255,255))
but4=pygame.image.load('images/other/button4.png')
but4.set_colorkey((255,255,255))
buttons.append(button(but1,pygame.Rect(0,640,64,64),'f'))
buttons.append(button(but2,pygame.Rect(64,640,64,64),'w'))
buttons.append(button(but3,pygame.Rect(128,640,64,64),''))
buttons.append(button(but4,pygame.Rect(256,640,64,64),'d'))

frame=pygame.image.load('images/other/frame.png')
frame.set_colorkey((255,255,255))

buttons2=change_tilemenu()
box=False

delete=False

#loop
while True:
 	#draw
 	window.fill((0,0,0))
 	editroom.draw()
 	for i in buttons:
 		window.blit(i.image, i.pos)
 		
 	for i in buttons2:
 		window.blit(i.image, i.pos)
 	
 	for i in tiles:
 		window.blit(frame, i.pos)	
 	
 	if box==True:
 		pygame.draw.rect(window, (0,255,0), (startpos[0], startpos[1], x,y))
 				
 	pygame.display.update()
 	
 	#test for event
 	for event in pygame.event.get():
 		if event.type==QUIT:
 			quit()
 		if event.type==KEYDOWN:
 			if event.key==K_ESCAPE:
 				quit()
 			if event.key==ord('s'):
 				save()
 		if event.type==MOUSEBUTTONDOWN:
 			for i in buttons:
 				if i.pos.collidepoint(event.pos[0],event.pos[1])==True:
 					if i.set!='d':
	 					tileset=i.set
	 					buttons2=change_tilemenu()
	 					delete=False
	 				else:
	 					delete=True
 			for i in buttons2:
 				if i.pos.collidepoint(event.pos[0],event.pos[1])==True:
 					currenttile=i.number
 					
 			startpos=(event.pos[0], event.pos[1])
 			box=True
 		
 		if box==True:	
	 		endpos=pygame.mouse.get_pos()		
			x=endpos[0]-startpos[0]
			y=endpos[1]-startpos[1]
 			
 		if event.type==MOUSEBUTTONUP:
 			box=False
 			endpos=(event.pos[0], event.pos[1])
 			
 			x=endpos[0]-startpos[0]
			y=endpos[1]-startpos[1]
 			
 			rect=pygame.Rect(startpos[0],startpos[1],x,y)
 			
 			for t in tiles:				
 				if t.pos.colliderect(rect)==True:
 					if delete==False:
	 					if tileset == 'f':
	 						editroom.tiles[t.y][t.x]=currenttile
	 					else:
	 						editroom.objects[t.y][t.x]=currenttile
	 				else:
	 					editroom.tiles[t.y][t.x]='00'
	 					editroom.objects[t.y][t.x]='00'